

var superDrag = {
		
   loaded: false,
         
   onLoad: function()
    {
    	// Overwrite original functions with modified versions if not already done
    	
  	if(!this.loaded)
  	{ 		
  		var tabbrowser = document.getElementById("content");
		tabbrowser.addEventListener('dragover', function(event) {nsDragAndDrop.dragOver(event, contentAreaDNDObserver);} , false);
		tabbrowser.addEventListener('drop', function(event) {nsDragAndDrop.dragOver(event, contentAreaDNDObserver);} , false);
  		contentAreaDNDObserver.onDragOver = superDrag.onDragOver;
		contentAreaDNDObserver.onDrop = superDrag.onDrop;
		nsDragAndDrop.checkCanDrop = superDrag.checkCanDrop;
		this.loaded = true;		
	}
  }, 	
  onDragOver: function(aEvent, aFlavour, aDragSession)
  {
    aEvent.target.setAttribute("dragover", "true");
    aDragSession.canDrop=true;
    return true;
  },
  
  onDrop: function (aEvent, aXferData, aDragSession)
    {
//      var myUrl = transferUtils.retrieveURLFromData(aXferData.data, aXferData.flavour.contentType);

      // valid urls don't contain spaces ' '; if we have a space it isn't a valid url so bail out
//      if (!myUrl || !myUrl.length || myUrl.indexOf(" ", 0) != -1) 
//        return;
     var prefService = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch('superdrag.settings.');
	
	
      // Get the preferences service
    var gPrefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch(null);
   

     switch (document.firstChild.getAttribute('windowtype')) {
        case "navigator:browser":
       	 var xferData = aXferData.data.split("\n");
      	 var uri = xferData[0] ? xferData[0] : xferData[1];
  	 if (uri)
      		{
      			// url test      			
      			
      			var DomainName = /(\w+(\-+\w+)*\.)+\w{2,7}/ ;
      			var HasSpace = /\S\s+\S/;
      			var forceAsURL = DomainName.test(uri) && (!HasSpace.test(uri));
      			     			
      			if( forceAsURL || (/^(file\:\/\/\/)/.test(uri)) ) //force it to a url or local file/directory
      			{
      				//my general file protocol match  is added from 0.2.2 and handle the local file dropped in by system's addTab() function.
      				//for firefox 0.8, if xpi file dropped in and then choose to cancel will cause firefox closing 
      				//clash: I don't why.
      				//MonkeySage's matching code and installer is need for 0.9
      				//for  0.8 addTab() alone works ok
      				
      				//check if an external xpi file is dropped.
      				if (/^(file\:\/\/\/)/.test(uri)&&/([^\/]+\.xpi)$/.test(uri))
      				{
      					eval("InstallTrigger.install({ '" + RegExp.$1 + "' : uri })");                 		 		
                 		 	break;              			 	
              			 }
      				
      				//check if the an internal image is dropped
      				if(aDragSession.sourceNode != null && !(/^(file\:\/\/\/)/.test(uri)) )
      				{
      					if(!aEvent.ctrlKey && aDragSession.sourceNode.nodeName == 'IMG' )
      					{
      						var DragImgDownload=true;
      						try
						{
							DragImgDownload =prefService.getBoolPref('dragimgdownload');
						}
						catch (err) {}
					
      						if (DragImgDownload)
						{				
      						
							var ImgDownloadOption = "dlmg";
							try
							{
								ImgDownloadOption = prefService.getCharPref('strimgdownloadoption');
							}
							catch (err) {}		
													
     							if(ImgDownloadOption=="dlmg")
     							{
     								saveURL(aDragSession.sourceNode.src, null, null, false, true);
    						 
    							}
    							else if(ImgDownloadOption=="dffd")
    							{
    						 	 superDrag.saveImage(aDragSession.sourceNode.src);
    						 					 	
    						 	}
      			 				break;
   			 			}   
   			 		}    				
   			 	}
      				
      				{//default action: open it to a new tab
              				
      					var newTab = getBrowser().addTab(uri);
      					var LoadLinkinFg=false;
      				     	try
					{
						LoadLinkinFg =prefService.getBoolPref('loadlinkinfg');
					}
					catch (err) {}			
      					if(LoadLinkinFg)
            					getBrowser().selectedTab = newTab;
            			}
      			}
      			else		     //it's a text string, so search it
      			{
      				// part of following code is borrowed from extension "Web Search Plus" created by Pike
      				var openURL = null;
      				// If the search bar is available and "Find in this Page" is not selected then use it
				if (superDrag.isSearchEngine())
				{
					openURL = superDrag.getSearchUrl(uri);
				}
			else // Else use default search engine
				{
					 var gNavigatorRegionBundle = null ;
   					 try{
   					 	gNavigatorRegionBundle= document.getElementById("bundle_browser_region");
					 }
					 catch(e){}
   					 if(!gNavigatorRegionBundle)
    					{
    						try{
    							gNavigatorRegionBundle= document.getElementById("bundle_navigator_region");
							}
						catch(e){}
   
     					}
					
					
					var fallbackDefaultSearchURL = gNavigatorRegionBundle.getString("fallbackDefaultSearchURL");
					
					var defaultSearchURL = null;
					try
					{
					defaultSearchURL = gPrefService.getComplexValue('browser.search.defaulturl', Components.interfaces.nsIPrefLocalizedString).data;
					}
					catch (err)
					{
						throw("browser.search.defaulturl can't be queried from chrome://browser-region/locale/region.properties.");
					}
					
					if (!defaultSearchURL)
    						defaultSearchURL = fallbackDefaultSearchURL;
    					
    					if(!defaultSearchURL)
    						break;
    						
					openURL = defaultSearchURL + encodeURIComponent(uri);
				}
     			
     				 var newTab = getBrowser().addTab(openURL);
          			 //if (!gPrefService.getBoolPref("browser.tabs.loadInBackground"))
          			 
            			var LoadSearchinFg = true;
      				try
				{
				 	LoadSearchinFg = prefService.getBoolPref('loadsearchinfg');
				}
				catch (err) {}			
      				if(LoadSearchinFg)
            				getBrowser().selectedTab = newTab;
            				
      			}  
         
	}
	break;
        case "navigator:view-source":
          viewSource(myUrl);
         break;
      }
      
      // keep the event from being handled by the dragDrop listeners
      // built-in to gecko if they happen to be above us.    
      aEvent.preventDefault();
      aEvent.preventBubble();
     
    },
    
    
    //the following function provided by NetOne makes dropping on current dragged image possible, hence no need
    //to drag an image out of itself to start download anymore.
      checkCanDrop: function (aEvent, aDragDropObserver)
    {
      if (!this.mDragSession)
        this.mDragSession = this.mDragService.getCurrentSession();
      if (!this.mDragSession)
        return false;
      /* The next line of code is used to allow dropping on the source node if the source node is an IMG element */
       
        this.mDragSession.canDrop = this.mDragSession.sourceNode != aEvent.target;
         
        if(this.mDragSession.sourceNode)   
      		if( this.mDragSession.sourceNode.nodeName == 'IMG')
              	 this.mDragSession.canDrop = true;        
       
          
      if ("canDrop" in aDragDropObserver)
        this.mDragSession.canDrop &= aDragDropObserver.canDrop(aEvent, this.mDragSession);
      return true;
    }, 
    
     getDownloadFolder: function(){
    	var prefService = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch('superdrag.settings.');
  	const nsILocalFile = Components.interfaces.nsILocalFile;
    	var dir = null;    						 	
	try {
    		dir = prefService.getCharPref("defaultfolder");
 	 }
	catch (e) { }
	
	if(dir == null||dir.length==0)
	 {
		 function getDesktopKey()
     		 {      
      			return "DeskV";
        		return "Home";
      		}
      		var fileLocator = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties);    
      		dir = fileLocator.get(getDesktopKey(), Components.interfaces.nsILocalFile);
      		return dir.path;
	}
	return dir;	
   },
    
   saveImage: function(src)
   {
   	
     // alert("get into saveImage");
      var fileName = src.substring(src.lastIndexOf('/')+1, src.length);
      var fileSaving = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
      var path = superDrag.getDownloadFolder() + "\\";
      fileSaving.initWithPath(path);
      
 //     alert("get out saveImage");
      
      if (!fileSaving.exists())
      {
         alert("The download folder does not exist!");
         return;
      }      

      fileSaving.initWithPath(path + fileName);
      var i = 1;
      var newFileName=fileName;
      
      while (fileSaving.exists())
      {
         if (fileName.indexOf('.') != -1)
         {
            var ext = fileName.substring(fileName.lastIndexOf('.'), fileName.length);
             var file = fileName.substring(0, fileName.length - ext.length);
             newFileName = file + "-" + i + ext;
             
            fileSaving.initWithPath(path + newFileName);
          }
          else
             fileSaving.initWithPath(path + fileName + i);
          i++;
      }
      
      var cacheKey  = Components.classes['@mozilla.org/supports-string;1'].createInstance(Components.interfaces.nsISupportsString);
      cacheKey.data = src;
      
      var urifix  = Components.classes['@mozilla.org/docshell/urifixup;1'].getService(Components.interfaces.nsIURIFixup);
      var uri     = urifix.createFixupURI(src, 0);
      var hosturi = null;

      if (uri.host.length > 0) {
         hosturi = urifix.createFixupURI(uri.host, 0);
      }


      var persist = Components.classes['@mozilla.org/embedding/browser/nsWebBrowserPersist;1'].createInstance(Components.interfaces.nsIWebBrowserPersist);
      persist.persistFlags = Components.interfaces.nsIWebBrowserPersist.PERSIST_FLAGS_FROM_CACHE | Components.interfaces.nsIWebBrowserPersist.PERSIST_FLAGS_CLEANUP_ON_FAILURE;
      persist.saveURI(uri, cacheKey, hosturi, null, null, fileSaving);
      
       function StatusLabel()
      {       			
      	var SaveLabel="The image has been saved to "+ path + " as " + newFileName ; 					
     	document.getElementById('statusbar-display').label = SaveLabel;
       }
      setTimeout(StatusLabel,100);
   },

    
    //isSearchEngine() is borrowed from extension "Web Search Plus" created by Pike
    isSearchEngine: function()
  	{
		var searchBar = document.getElementById('search-bar');
		if (!searchBar) return false;
		if (window.navigator.productSub && window.navigator.productSub < 20030807)
		// browser.js version 1.216 or less
		{
			return (searchBar.hasAttribute('searchmode'));
		}
		else if (window.navigator.productSub && window.navigator.productSub < 20031022)
		// browser.js version 1.217 to 1.240
		{
			return (searchBar.getAttribute('searchmode') != '__PhoenixFindInPage');
		}
		else
		// browser.js version 1.241 and above
		{
			return (searchBar.getAttribute('searchengine') != '__PhoenixFindInPage');
		}
	},

   //getSearchUrl() is borrowed from extension "Web Search Plus" created by Pike
   getSearchUrl: function(searchStr)
	{
		var searchBar = document.getElementById('search-bar');
		if (!searchBar) return null;
		var searchEngine = null;
		if (window.navigator.productSub && window.navigator.productSub < 20031022)
		// browser.js version 1.240 and below
		{
			searchEngine = searchBar.getAttribute('searchmode');
		}
		else
		// browser.js version 1.241 and above
		{
			searchEngine = searchBar.getAttribute('searchengine');
		}
		if (!searchEngine) return null;
		var iSearchService = Components.classes['@mozilla.org/rdf/datasource;1?name=internetsearch'].getService(Components.interfaces.nsIInternetSearchService);
		return iSearchService.GetInternetSearchURL(searchEngine, encodeURIComponent(searchStr), 0, 0, {value: 0});
	},

  
  getSupportedFlavours: function ()
    {
      var flavourSet = new FlavourSet();
      flavourSet.appendFlavour("text/x-moz-url");
      flavourSet.appendFlavour("text/unicode");
      flavourSet.appendFlavour("application/x-moz-file", "nsIFile");
      return flavourSet;
    }
  
}; 

window.addEventListener('load', function() {superDrag.onLoad();}, false);









